---
title: Client.postMessage()
slug: Web/API/Client/postMessage
tags:
  - API
  - Client
  - Experimental
  - Method
  - Reference
  - Service Workers
  - Service worker API
  - ServiceWorker
  - postMessage
---
<p>{{APIRef("Service Worker API")}}</p>

<p><span class="seoSummary">The <strong><code>postMessage()</code></strong> method of the {{domxref("Client")}} interface allows a service worker to send a message to a client (a {{domxref("Window")}}, {{domxref("Worker")}}, or {{domxref("SharedWorker")}}). The message is received in the "<code>message</code>" event on {{domxref("ServiceWorkerContainer", "navigator.serviceWorker")}}.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>client</var>.postMessage(<var>message</var>[, <var>transfer</var>]);
<var>client</var>.postMessage(<var>message</var>[, { transfer }]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>message</var></code></dt>
 <dd>The message to send to the client. This can be any <a href="/en-US/docs/Web/API/Web_Workers_API/Structured_clone_algorithm">structured-clonable type</a>.</dd>
 <dt><code><var>transfer</var></code> {{optional_inline}}</dt>
 <dd>A sequence of objects that are <a href="/en-US/docs/Web/API/Transferable">transferred</a> with the message. The ownership of these objects is given to the destination side and they are no longer usable on the sending side.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h2 id="Examples">Examples</h2>

<p>Sending a message from a service worker to a client:</p>

<pre class="brush: js notranslate">addEventListener('fetch', event =&gt; {
  event.waitUntil(async function() {
    // Exit early if we don't have access to the client.
    // Eg, if it's cross-origin.
    if (!event.clientId) return;

    // Get the client.
    const client = await clients.get(event.clientId);
    // Exit early if we don't get the client.
    // Eg, if it closed.
    if (!client) return;

    // Send a message to the client.
    client.postMessage({
      msg: "Hey I just got a fetch from you!",
      url: event.request.url
    });

  }());
});</pre>

<p>Receiving that message:</p>

<pre class="brush: js notranslate">navigator.serviceWorker.addEventListener('message', event =&gt; {
  console.log(event.data.msg, event.data.url);
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-client-postmessage-message-options', 'postMessage()')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Client.postMessage")}}</p>
</div>
